'use strict';

var preact = require('preact');

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Toggle = function (_Component) {
  _inherits(Toggle, _Component);

  function Toggle(props) {
    _classCallCheck(this, Toggle);

    var _this = _possibleConstructorReturn(this, (Toggle.__proto__ || Object.getPrototypeOf(Toggle)).call(this, props));

    _this.state = {
      enabled: _this.props.enabled || false
    };
    return _this;
  }

  _createClass(Toggle, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return preact.h(
        'div',
        {
          'class': ['switch', this.state.enabled ? 'on' : ''].join(' '),
          onClick: function () {
            return _this2.setState({ enabled: !_this2.state.enabled }, function () {
              _this2.props.onChange(_this2.state.enabled);
            });
          }.bind(this)
        },
        preact.h('div', { 'class': 'switch-toggle' })
      );
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      // if a parent changes the enabled prop value, reflect it to the state
      if (this.props.enabled !== prevProps.enabled) {
        this.setState({ enabled: this.props.enabled });
      }
    }
  }]);

  return Toggle;
}(preact.Component);

module.exports = Toggle;
